<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of SyntaxHighlightJS, a plugin for Dotclear 2.
# 
# Copyright (c) 2011 Nicolas Sebastien Pierre-Olivier GEORGES
# http://www.nicolas.georges.fr.free.fr/
# xlat@cpan.org
#
# Licensed under the Artistic License.
# A copy of this license is available in Artistic.txt file or at
# http://dev.perl.org/licenses/artistic.html
#
# -- END LICENSE BLOCK ------------------------------------

//~ if (!defined('DC_CONTEXT_ADMIN')) exit;
$core->addBehavior('coreInitWikiPost',array('SyntaxHighlightJS','registerFunc'));

class SyntaxHighlightJS
{	
	public static function registerFunc($wiki2xhtml)
	{
		$dir = dirname(__FILE__).'/shjs/lang/';
		$od = opendir($dir);
		while($f = readdir($od)){
			if(is_file($dir.$f) && substr($f,-3,3)=='.js'){
				//remove "sh_" and .js
				$lang = str_replace('.min.js','',$f);
				$lang = str_replace('.js','',$lang);
				$lang = str_replace('sh_','',$lang);
				//~ echo "DEBUG: $f => $lang<br/>
				$wiki2xhtml->registerFunction('macro:['.$lang.']',array('SyntaxHighlightJS','parse'));
			}
		}
	}

	public static function parse($text,$args)
	{	
	#TODO: 
	#		3) add a combobox to select highlight style 
	#			(to be a presentation widget)
	    global $core;
		$text = trim($text);
		$args = preg_replace("/^(\[(.*)\]$)/","$2",$args);	#Here is our language

		return "<pre class=\"sh_$args\">$text</pre>\n";
	}

}
?>
