<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of SyntaxHighlightJS, a plugin for Dotclear 2.
# 
# Copyright (c) 2011 Nicolas Sebastien Pierre-Olivier GEORGES
# http://www.nicolas.georges.fr.free.fr/
# xlat@cpan.org
#
# Licensed under the Artistic License.
# A copy of this license is available in Artistic.txt file or at
# http://dev.perl.org/licenses/artistic.html
#
# -- END LICENSE BLOCK ------------------------------------

//~ if (!defined('DC_CONTEXT_ADMIN')) exit;
$core->addBehavior('publicHeadContent',array('publicSyntaxHighlightJS','publicHeadContent'));
$core->addBehavior('publicEntryAfterContent',array('publicSyntaxHighlightJS','publicEntryAfterContent'));

class publicSyntaxHighlightJS
{
	
	public static function publicEntryAfterContent($core, $_ctx)
	{
		if(!$_ctx->exists('posts')){ return; }	#Don't display on post agregation
		if($_ctx->posts->post_type != 'post'){ return; }
		if('post.html' != $_ctx->current_tpl ){ return; }
		//~ $ns = $core->blog->settings->get('syntaxhighlightjs');
		//~ $mutex = $ns->get( "mutex" );
		$pluginfile = $core->blog->getQmarkURL().'pf=SyntaxHighlightJS/shjs';
		#TODO: dynamically build the list of styles
		#TODO: dynamically set "selected" on the right item (default one)
		echo "syntax highlighting: <select id=\"shjs_themeSelect\" onchange=\"return shjssw_switchStyle('$pluginfile/css/','.min.css',this);\">
<option>acid</option>
<option>berries-dark</option>
<option>berries-light</option>
<option>bipolar</option>
<option>blacknblue</option>
<option>bright</option>
<option>contrast</option>
<option>darkblue</option>
<option>darkness</option>
<option>desert</option>
<option>dull</option>
<option>easter</option>
<option>emacs</option>
<option>golden</option>
<option>greenlcd</option>
<option>ide-anjuta</option>
<option>ide-codewarrior</option>
<option>ide-devcpp</option>
<option>ide-eclipse</option>
<option>ide-kdev</option>
<option>ide-msvcpp</option>
<option selected>ide-pb</option>
<option>kwrite</option>
<option>matlab</option>
<option>navy</option>
<option>nedit</option>
<option>neon</option>
<option>night</option>
<option>pablo</option>
<option>peachpuff</option>
<option>print</option>
<option>rand01</option>
<option>the</option>
<option>typical</option>
<option>vampire</option>
<option>vibrant-ink</option>
<option>vim</option>
<option>vim-dark</option>
<option>whatis</option>
<option>whitengrey</option>
<option>zellner</option>
</select>
";
	}
	
	public static function publicHeadContent($core, $_ctx)
	{
		$pluginfile = $core->blog->getQmarkURL().'pf=SyntaxHighlightJS/shjs';
		#Todo read from settings for default theme
		$initialstyle = "ide-pb";
		echo "
<!-- # SyntaxHighlightJS -->
<script type=\"text/javascript\" src=\"$pluginfile/sh_main.js\"></script>
<script type=\"text/javascript\" src=\"$pluginfile/sh_stylesw.js\"></script>
<script type=\"text/javascript\">
//<![CDATA[
function shjsbs_onload_ie_safari_chrome_firefox(){
	if (/loaded|complete/.test(document.readyState)) {
		sh_highlightDocument('$pluginfile/lang/', '.min.js', '$initialstyle.min', '$pluginfile/css/');
	}
	else{
		setTimeout('shjsbs_onload_ie_safari_chrome_firefox()', 250);
	}
}
shjsbs_onload_ie_safari_chrome_firefox();
//]]>
</script>
";
	}
}

?>