/*
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of SyntaxHighlightJS, a plugin for Dotclear 2.
# 
# Copyright (c) 2011 Nicolas Sebastien Pierre-Olivier GEORGES
# http://www.nicolas.georges.fr.free.fr/
# xlat@cpan.org
#
# Licensed under the Artistic License.
# A copy of this license is available in Artistic.txt file or at
# http://dev.perl.org/licenses/artistic.html
#
# -- END LICENSE BLOCK ------------------------------------
*/
function shjssw_loadStyle(stylepath){
  var oLink = document.createElement('link');
  oLink.setAttribute('href', stylepath);
  oLink.setAttribute('rel', 'stylesheet');
  oLink.setAttribute('type', 'text/css');
  document.getElementsByTagName('head')[0].appendChild(oLink);
}

function shjssw_switchStyle(prefix,ext,select) {
  var value = select.options[select.selectedIndex].innerHTML;
  stylepath = prefix + 'sh_' + value + ext;
  //~ alert( "shjssw_switchStyle : stylepath = '"+stylepath+"'" );
  var styleexist = false;
  select.disabled = true;
  for(link in document.getElementsByTagName('link')){
	  if(link.href && link.href.substring(0, prefix.length)==prefix ){
		  if(link.href == stylepath){
			  link.disabled = false;
			  styleexist = true;
		  }
		  else{
			  link.disabled = true;
		  }
	  }
  }
  if (!styleexist) {
    shjssw_loadStyle(stylepath);
  }
  select.disabled = false;
}